--[[
	Author: Darcey.Lloyd@gmail.com

	USEFUL TO GET FRAME NAME IN GAME CHAT:
	/run print(GetMouseFocus():GetName() .. "\n")
--]]



-- Addon Global Variables (shared between files but not addons). addon var name can be renamed
local AddOnName, addon = ...;
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #






-- setup mainFrame
addon.setupMainBar = function()
    -- MainFrame
	addon.mainBar.frame = CreateFrame("frame","DCoordsMainBar",UIParent);
    addon.mainBar.frame:SetFrameStrata("HIGH");
    addon.mainBar.frame:EnableMouse(true);
	addon.mainBar.frame:SetResizable(true);
	addon.mainBar.frame:SetMovable(true);
    addon.mainBar.frame:SetWidth(200);
	addon.mainBar.frame:SetHeight(200);
	addon.mainBar.frame:SetClampedToScreen(true)
	
	addon.mainBar.frame.texture = addon.mainBar.frame:CreateTexture(nil, "BACKGROUND")
	addon.mainBar.frame.texture:SetAllPoints(true)
	addon.mainBar.frame.texture:SetColorTexture(
		DCoordsDB["MainBar"].bgR,
		DCoordsDB["MainBar"].bgG,
		DCoordsDB["MainBar"].bgB,
		DCoordsDB["MainBar"].bgA
	)
    
	addon.mainBar.frame:ClearAllPoints(true);
	-- addon.mainBar.frame:SetPoint(DCoordsDB["MainBar"].anchor,DCoordsDB["MainBar"].x,DCoordsDB["MainBar"].y);
	addon.mainBar.frame:SetPoint("BOTTOMLEFT",DCoordsDB["MainBar"].x,DCoordsDB["MainBar"].y);




	-- Drag
    -- OnDragStart
	addon.mainBar.frame:RegisterForDrag("LeftButton");
	addon.mainBar.frame:SetScript("OnMouseDown", function(self)
		if (DTools.isInCombat() == false) then
			if (IsShiftKeyDown()) then 
				addon.mainBar.frame:StartMoving();
				addon.mainBar.dragStarted = true;
			end 
		end
	end);

    -- OnDragStop
	addon.mainBar.frame:SetScript("OnMouseUp", function(self,buttonIdentifier)
		if (addon.mainBar.dragStarted == true) then
			DCoordsDB["MainBar"].x = addon.mainBar.frame:GetLeft();
			DCoordsDB["MainBar"].y = addon.mainBar.frame:GetTop()-addon.mainBar.frame:GetHeight();
			addon.mainBar.frame:StopMovingOrSizing()
			addon.mainBar.dragStarted = false
		end

		if (buttonIdentifier == "RightButton") then
			if (DTools.isInCombat() == false) then
				addon.slashCommandHandler("menu")
			end
		end
	end);
	
	
	-- MainFrame label
	-- DTools.createText = function(frame,label,fontSize,justify,x,y,r,g,b,font)
	addon.mainBar.label = addon.mainBar.frame:CreateFontString(nil, 'ARTWORK');
	addon.mainBar.label:SetPoint("TOPLEFT",frame,"TOPLEFT", 0, 0);
    addon.mainBar.label:SetFont(addon.getMainBarFont(), DCoordsDB["MainBar"].labelFontSize,"OUTLINE");
    addon.mainBar.label:SetShadowOffset(1, -1);
    addon.mainBar.label:SetTextColor(
		DCoordsDB["MainBar"].labelR,
		DCoordsDB["MainBar"].labelG,
		DCoordsDB["MainBar"].labelB
	);
    addon.mainBar.label:SetNonSpaceWrap(false);
	addon.mainBar.label:SetText(addon.tempLabel);
	addon.mainBar.label:SetJustifyH("LEFT");
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #







-- addon.updateMainBarDimensions
addon.updateMainBarDimensions = function()
	-- Dont do any dimensional changes when in combat!
	if (DTools.isInCombat() == false) then
		local labelW = addon.mainBar.label:GetWidth();
		local labelH = addon.mainBar.label:GetHeight();

		local targetW = DCoordsDB["MainBar"].labelPaddingX + labelW;
		local targetH = DCoordsDB["MainBar"].labelPaddingY + labelH;

		local mainBarW = addon.mainBar.frame:GetWidth();
		local mainBarH = addon.mainBar.frame:GetHeight();

		-- local msg = "";
		-- msg = msg .. "  lW:" .. DTools.roundTo(labelW,2)
		-- msg = msg .. "  lH:" .. DTools.roundTo(labelW,2)
		-- msg = msg .. "  tW:" .. DTools.roundTo(targetW,2)
		-- msg = msg .. "  tH:" .. DTools.roundTo(labelW,2)
		-- msg = msg .. "  w:" .. DTools.roundTo(mainBarW,2)
		-- msg = msg .. "  h:" .. DTools.roundTo(mainBarH,2)
		-- print(msg)

		-- Only update if dimensions are not correct
		if (mainBarW ~= targetW or mainBarH ~= targetH) then
			-- Position label
			local labelX = (DCoordsDB["MainBar"].labelPaddingX/2) + DCoordsDB["MainBar"].labelOffsetX
			local labelY = -(DCoordsDB["MainBar"].labelPaddingY/2) + DCoordsDB["MainBar"].labelOffsetY
			addon.mainBar.label:SetPoint("TOPLEFT",labelX,labelY);

			-- Set size of mainBar frame (NOT containerFrame)
			addon.mainBar.frame:SetWidth(targetW)
			addon.mainBar.frame:SetHeight(targetH)

			-- addon.mainBar.frame:SetWidth(targetW);
			-- addon.mainBar.frame:SetHeight(targetH);
		end

		-- if (mainBarW ~= targetW or mainBarH ~= targetH) then
		-- 	DTools.log("ERROR SET WIDTH ")
		-- end
	end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #









-- addon.updateMainBarLabelText
addon.updateMainBarLabelText = function()
	local location = ""

	if (DCoordsDB["MainBar"].showZone == true and DCoordsDB["MainBar"].showSubZone == true) then
		-- true true
		if (addon.location.zone ~= "" and addon.location.subZone ~= "") then
			location = addon.location.zone .. " - " .. addon.location.subZone;
		elseif (addon.location.zone == "" and addon.location.subZone ~= "") then
			location = addon.location.subZone;
		elseif (addon.location.zone ~= "" and addon.location.subZone == "") then
			location = addon.location.zone;
		end

	elseif (DCoordsDB["MainBar"].showZone == true and DCoordsDB["MainBar"].showSubZone == false) then
		-- true false
		if (addon.location.zone ~= "") then
			location = addon.location.zone;
		end

	elseif (DCoordsDB["MainBar"].showZone == false and DCoordsDB["MainBar"].showSubZone == true) then
		-- false true
		if (addon.location.subZone ~= "") then
			location = addon.location.subZone;
		end

	else
		-- false false
	end


	if (addon.coords ~= nil) then
		local coords = addon.coords.x .. DCoordsDB["CoordsSeperationString"] .. addon.coords.y;
		
		if (addon.mainBar.frame:IsVisible()) then

			if (location ~= "") then
				addon.mainBar.text = location .. " : " .. coords
			else
				addon.mainBar.text = coords
			end

			-- Only update if new location text is not the same as old location text
			if (addon.mainBar.text ~= addon.mainBar.oldText) then
				addon.mainBar.oldText = addon.mainBar.text
				addon.mainBar.label:SetText(addon.mainBar.text)
			end
		end
		
	else
		if (location ~= "") then
			addon.mainBar.text = location .. " : 0 - 0"
		else
			addon.mainBar.text = "0 - 0"
		end
		addon.mainBar.label:SetText(addon.mainBar.text)
	end



	-- update MainFrame width and height to fit text
	-- addon.updateMainBarAnchorAndLocation();
	addon.updateMainBarDimensions();
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #






addon.setMainBarBackground = function()
	-- print("DCoordsDB[MainBar].showBackground = " .. DTools.boolToString(DCoordsDB["MainBar"].showBackground))
	-- print("DCoordsDB[MainBar].backgroundIndex = " .. DCoordsDB["MainBar"].backgroundIndex)


	if (DCoordsDB["MainBar"].backgroundIndex == 1) then
		-- Classic border frame
		local tileSize = 10;
		local edgeSize = 10;
		local insets = 3;
		
		addon.mainBar.frame:SetBackdrop(nil); -- Hide/Remove classic frame
		addon.mainBar.frame:SetBackdrop({
			bgFile = "Interface/DialogFrame/UI-DialogBox-Background",
			edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
			tile = true, tileSize = tileSize, edgeSize = edgeSize,
			insets = { left = insets, right = insets, top = insets, bottom = insets }
		})

		-- Hide texture bg
		addon.mainBar.frame.texture:SetColorTexture(0,0,0,0)

	elseif (DCoordsDB["MainBar"].backgroundIndex == 2) then
		-- Borderless background
		addon.mainBar.frame:SetBackdrop(nil); -- Hide/Remove classic frame

		addon.mainBar.frame.texture:SetColorTexture(
			DCoordsDB["MainBar"].bgR,
			DCoordsDB["MainBar"].bgG,
			DCoordsDB["MainBar"].bgB,
			DCoordsDB["MainBar"].bgA
		)
	else
		-- no background
		addon.mainBar.frame:SetBackdrop(nil); -- Hide/Remove classic frame
		addon.mainBar.frame.texture:SetColorTexture(0,0,0,0)
	end
	

	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- TODO: Anchor point changes all the time don't change it for now work it out later
addon.setMainBarAnchor = function()
	print("addon.setMainBarAnchor()")
	local anchor = addon.menu.anchorOptions[DCoordsDB["MainBar"].labelAnchorIndex]
	print("anchor = " .. anchor);
	addon.mainBar.frame:SetPoint(addon.mainBar.frame,anchor,0,0);
	-- addon.mainBar.frame:SetPoint(strata, "UIParent", strata, DCoordsDB["MainBar"].x,DCoordsDB["MainBar"].y);
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




addon.setMainBarLabelStyle = function()
	addon.mainBar.label:SetTextColor(
		DCoordsDB["MainBar"].labelR,
		DCoordsDB["MainBar"].labelG,
		DCoordsDB["MainBar"].labelB,
		DCoordsDB["MainBar"].labelA
	)

	addon.mainBar.label:SetFont(addon.getMainBarFont(), DCoordsDB["MainBar"].labelFontSize,"OUTLINE");

	-- Force a text update
	addon.mainBar.text = " -- "
	addon.mainBar.oldText = "- UPDATE -"

	addon.mainBar.label:SetText(" - - - ")
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #






addon.initMainBarState = function()
	if (DCoordsDB["MainBar"].enabled == true) then
		addon.mainBar.frame:Show();
		addon.setMainBarBackground();
	else
		addon.mainBar.frame:Hide();
	end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #