--[[
	Author: Darcey.Lloyd@gmail.com

	USEFUL TO GET FRAME NAME IN GAME CHAT:
	/run print(GetMouseFocus():GetName() .. "\n")
--]]



-- Addon Global Variables (shared between files but not addons). addon var name can be renamed
local AddOnName, addon = ...;
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- Var ini
addon.name = "DCCaddon.lua > addon.name"
addon.version = "1.2.10"
addon.name = "DCoords Classic"
addon.debug = false;

addon.initComplete = false;

addon.coords = {}
addon.coords.x = 0
addon.coords.y = 0

addon.tempLabel = "AWAITING GAME DATA"

addon.location = {}
addon.location.zone = nil
addon.location.subZone = nil
addon.location.text = ""
addon.location.label = nil

addon.mainBar = {};
addon.mainBar.container = nil -- contains addon.mainBar.frame
addon.mainBar.frame = nil;
addon.mainBar.label = nil;
addon.mainBar.text = "";
addon.mainBar.oldText = addon.tempLabel;
addon.mainBar.dragStarted = false;

addon.worldMap = {}
addon.worldMap.label = nil;

addon.miniMap = {}

addon.menu = {}
addon.menu.api = nil
addon.menu.mainPage = nil
addon.menu.mainBar = nil
addon.menu.worldMap = nil
addon.menu.miniMap = nil
addon.menu.titleTextSize = 18
addon.menu.textSize = 12

addon.menu.anchorOptions = {};
addon.menu.anchorOptions[1] = "BOTTOMLEFT";
addon.menu.anchorOptions[2] = "BOTTOM";
addon.menu.anchorOptions[3] = "BOTTOMRIGHT";



addon.menu.backgroundOptions = {};
addon.menu.backgroundOptions[1] = "Classic";
addon.menu.backgroundOptions[2] = "Borderless";
addon.menu.backgroundOptions[3] = "None";


addon.time = {}
addon.time.now = 99999999;
addon.time.prev = 0;
addon.time.updateFreq = 1000; -- Milliseconds 1000 = 1 sec
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- Fonts
addon.sharedMedia = LibStub("LibSharedMedia-3.0")

addon.fontPath = "Interface\\Addons\\DCoordsClassic\\Fonts\\";
addon.fonts = {
	"AccidentalPresidency.ttf",
	"Lora-Regular.ttf",
	"Montserrat-Regular.ttf",
	"OpenSans-CondBold.ttf",
	"OpenSans-CondLight.ttf",
	"OpenSans-CondLightItalic.ttf",
	"MORPHEUS.TTF",
	"NotoSans-Bold.ttf",
	"NotoSans-Italic.ttf",
	"NotoSans-Regular.ttf",
	"stonehen.ttf",
	"tiffanynormal.ttf",
	"ARAMIS.TTF",
	"BRAVADO.TTF",
	"DIGIWOI_.TTF",
	"Bender.ttf"
}

-- Register fonts
for i=1,#addon.fonts do
	local fontPath = addon.fontPath..addon.fonts[i];
	addon.sharedMedia:Register ("font", "Font " .. tostring(i), fontPath)
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #








-- addon.initPersistentVars
addon.initPersistentVars = function()
	if (not DCoordsDB) then
		DCoordsDB = {}
	end


	-- Working vars
	if (DCoordsDB["UpdateFrequency"] == nil) then
		DCoordsDB["UpdateFrequency"] = 0.1;
	end

	if (DCoordsDB["CoordinatesAccuracy"] == nil) then
		DCoordsDB["CoordinatesAccuracy"] = 2;
	end

	if (DCoordsDB["CoordsSeperationString"] == nil) then
		DCoordsDB["CoordsSeperationString"] = " - ";
	end




	-- MainBar
	if (DCoordsDB["MainBar"] == nil) then
		DCoordsDB["MainBar"] = {}
	end

	if (DCoordsDB["MainBar"].enabled == nil) then
		DCoordsDB["MainBar"].enabled = true
	end

	if (DCoordsDB["MainBar"].x == nil) then
		DCoordsDB["MainBar"].x = 0
	end

	if (DCoordsDB["MainBar"].y == nil) then
		DCoordsDB["MainBar"].y = 0
	end

	if (DCoordsDB["MainBar"].anchor == nil) then
		DCoordsDB["MainBar"].anchor = "BOTTOMLEFT"
	end

	if (DCoordsDB["MainBar"].anchorIndex == nil) then
		DCoordsDB["MainBar"].anchorIndex = 1
	end

	if (DCoordsDB["MainBar"].labelFontSize == nil) then
		DCoordsDB["MainBar"].labelFontSize = 12
	end

	if (DCoordsDB["MainBar"].labelFontIndex == nil) then
		DCoordsDB["MainBar"].labelFontIndex = 1
	end

	if (DCoordsDB["MainBar"].labelR == nil) then
		DCoordsDB["MainBar"].labelR = 1
	end

	if (DCoordsDB["MainBar"].labelG == nil) then
		DCoordsDB["MainBar"].labelG = 1
	end

	if (DCoordsDB["MainBar"].labelB == nil) then
		DCoordsDB["MainBar"].labelB = 1
	end

	if (DCoordsDB["MainBar"].labelA == nil) then
		DCoordsDB["MainBar"].labelA = 1
	end

	if (DCoordsDB["MainBar"].labelPaddingX == nil) then
		DCoordsDB["MainBar"].labelPaddingX = 5
	end

	if (DCoordsDB["MainBar"].labelPaddingY == nil) then
		DCoordsDB["MainBar"].labelPaddingY = 6
	end

	if (DCoordsDB["MainBar"].labelOffsetX == nil) then
		DCoordsDB["MainBar"].labelOffsetX = 0
	end

	if (DCoordsDB["MainBar"].labelOffsetY == nil) then
		DCoordsDB["MainBar"].labelOffsetY = 0
	end

	if (DCoordsDB["MainBar"].labelAnchorIndex == nil) then
		DCoordsDB["MainBar"].labelAnchorIndex = 1
	end

	if (DCoordsDB["MainBar"].backgroundIndex == nil) then
		DCoordsDB["MainBar"].backgroundIndex = 1
	end

	if (DCoordsDB["MainBar"].bgR == nil) then
		DCoordsDB["MainBar"].bgR = 0
	end

	if (DCoordsDB["MainBar"].bgG == nil) then
		DCoordsDB["MainBar"].bgG = 0
	end

	if (DCoordsDB["MainBar"].bgB == nil) then
		DCoordsDB["MainBar"].bgB = 0
	end

	if (DCoordsDB["MainBar"].bgA == nil) then
		DCoordsDB["MainBar"].bgA = 0.5
	end

	if (DCoordsDB["MainBar"].showZone == nil) then
		DCoordsDB["MainBar"].showZone = true
	end

	if (DCoordsDB["MainBar"].showSubZone == nil) then
		DCoordsDB["MainBar"].showSubZone = true
	end


	-- World Map
	if (DCoordsDB["WorldMap"] == nil) then
		DCoordsDB["WorldMap"] = {}
	end

	if (DCoordsDB["WorldMap"].enabled == nil) then
		DCoordsDB["WorldMap"].enabled = true
	end

	if (DCoordsDB["WorldMap"].fontSize == nil) then
		DCoordsDB["WorldMap"].fontSize = 12
	end

	if (DCoordsDB["WorldMap"].fontIndex == nil) then
		DCoordsDB["WorldMap"].fontIndex = 1
	end

	if (DCoordsDB["WorldMap"].x == nil) then
		DCoordsDB["WorldMap"].x = 6
	end

	if (DCoordsDB["WorldMap"].y == nil) then
		DCoordsDB["WorldMap"].y = -6
	end

	if (DCoordsDB["WorldMap"].r == nil) then
		DCoordsDB["WorldMap"].r = 1
	end

	if (DCoordsDB["WorldMap"].g == nil) then
		DCoordsDB["WorldMap"].g = 1
	end

	if (DCoordsDB["WorldMap"].b == nil) then
		DCoordsDB["WorldMap"].b = 1
	end

	if (DCoordsDB["WorldMap"].offsetX == nil) then
		DCoordsDB["WorldMap"].offsetX = 0
	end

	if (DCoordsDB["WorldMap"].offsetY == nil) then
		DCoordsDB["WorldMap"].offsetY = 0
	end


	-- Minimap
	if (DCoordsDB["MiniMap"] == nil) then
		DCoordsDB["MiniMap"] = {}
	end

	if (DCoordsDB["MiniMap"].enable == nil) then
		DCoordsDB["MiniMap"].enable = true
	end


	-- Menu Options



end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

