--[[
	Name: Classic DCoords
	Author: Darcey.Lloyd@gmail.com

	USEFUL TO GET FRAME NAME IN GAME CHAT:
	/run print(GetMouseFocus():GetName() .. "\n")
--]]

-- Addon Global Variables (shared between files but not addons). addon var name can be renamed
local AddOnName, addon = ...;
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- addon.init
addon.init = function()
	-- force a hard reset of DCoordsDB
	-- DCoordsDB = nil;

	-- Setup
	addon.initPersistentVars();
	addon.setupMainBar();
	addon.setupWorldMap();
	addon.setupMenu();

	-- State
	addon.initMainBarState()
	addon.setMainBarLabelStyle();
	addon.initWorldMapState();


	-- Setup slash commands
	SlashCmdList["DCCoordsCOMMAND"] = addon.slashCommandHandler;
	SLASH_DCCoordsCOMMAND1 = "/dc";

	-- Welcome message
	print(" ")
	DTools.log("DCoords Classic: Type /dc for options","00CC00")
	DTools.log("DCoords Classic: To drag, hold shift and left click drag.","007700")

	-- init complete flag
	addon.initComplete = true;

end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- addon.slashCommandHandler
addon.slashCommandHandler = function(cmd)
	if (addon.debug) then
		print("addon.slashCommandHandler(cmd:" .. cmd ..")");
	end

	-- Open DCoords menu, open sub menu and then back to root page
	if (addon.menu.mainPage ~= nil) then
		InterfaceOptionsFrame_OpenToCategory(addon.menu.mainPage.name);
		InterfaceOptionsFrame_OpenToCategory(addon.menu.mainBar.name);
		InterfaceOptionsFrame_OpenToCategory(addon.menu.mainPage.name);
	else
		print("DCoords classic - menu page not available, please use in game menu to get to addon settings!")
	end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- This should be done last so everything is available to it
addon.eventFrame = CreateFrame("frame","ClassiDCCoordsEventFrame");
addon.eventFrame:RegisterEvent("VARIABLES_LOADED");
addon.eventFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
addon.eventFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
addon.eventFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
addon.eventFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
addon.eventFrame:RegisterEvent("ZONE_CHANGED_INDOORS");
addon.eventFrame:RegisterEvent("ZONE_CHANGED");
addon.eventFrame:SetScript("OnEvent", function(self,event,addonName)
		if (event == "VARIABLES_LOADED") then
			if (addon.debug) then
				DTools.log("event:" .. event,"00CC00")
			end
			addon.getZoneDetails();
			addon.init();
		elseif (event == "ZONE_CHANGED") then
			addon.getZoneDetails();
		elseif (event == "ZONE_CHANGED_NEW") then
			addon.getZoneDetails();
		elseif (event == "ZONE_CHANGED_NEW_AREA") then
			addon.getZoneDetails();
		elseif (event == "ZONE_CHANGED_INDOORS") then
			addon.getZoneDetails();
		end
	end
)
addon.eventFrame:SetScript("OnUpdate",addon.onUpdateHandler)
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
